# Installation

The instructions below will help you to properly install the generated package to the lavalite project.

## Location

Extract the package contents to the folder 

`/packages/localhost/c_m_s,_email_marketing/`

## Composer

Add the below entries in the `composer.json` file's autoload section and run the command `composer dump-autoload` in terminal.

```json

...
     "autoload": {

        "psr-4": {
            ... ,
            "Localhost\\CMS,EmailMarketing\\": "packages/localhost/c_m_s,_email_marketing/src",
            "Localhost\\CMS,EmailMarketing\\Seeders\\": "packages/localhost/c_m_s,_email_marketing/database/seeders"
            
            ...
        }
    },
...

```

## Config

Add the entries in service provider in `config/app.php`

```php

...
    'providers'       => [
        ...
        
        Localhost\CMS,EmailMarketing\Providers\CMS,EmailMarketingServiceProvider::class,
        
        ...
    ],

    ...

    'alias'             => [
        ...
        
        'CMS,EmailMarketing'  => Localhost\CMS,EmailMarketing\Facades\CMS,EmailMarketing::class,
        
        ...
    ]
...

```

## Migrate

After service provider is set run the commapnd to migrate and seed the database.


    php artisan migrate
    php artisan db:seed --class=Localhost\\CMS,EmailMarketing\\Seeders\\CMS,EmailMarketingTableSeeder

## Publishing


**Publishing configuration**

    php artisan vendor:publish --provider="Localhost\CMS,EmailMarketing\Providers\CMS,EmailMarketingServiceProvider" --tag="config"

**Publishing language**

    php artisan vendor:publish --provider="Localhost\CMS,EmailMarketing\Providers\CMS,EmailMarketingServiceProvider" --tag="lang"

**Publishing views**

    php artisan vendor:publish --provider="Localhost\CMS,EmailMarketing\Providers\CMS,EmailMarketingServiceProvider" --tag="view"


## URLs and APIs


### Web Urls

**Admin**

    http://path-to-route-folder/admin/c_m_s,_email_marketing/{modulename}

**User**

    http://path-to-route-folder/user/c_m_s,_email_marketing/{modulename}

**Public**

    http://path-to-route-folder/c_m_s,_email_marketings


### API endpoints

**List**
 
    http://path-to-route-folder/api/user/c_m_s,_email_marketing/{modulename}
    METHOD: GET

**Create**

    http://path-to-route-folder/api/user/c_m_s,_email_marketing/{modulename}
    METHOD: POST

**Edit**

    http://path-to-route-folder/api/user/c_m_s,_email_marketing/{modulename}/{id}
    METHOD: PUT

**Delete**

    http://path-to-route-folder/api/user/c_m_s,_email_marketing/{modulename}/{id}
    METHOD: DELETE

**Public List**

    http://path-to-route-folder/api/c_m_s,_email_marketing/{modulename}
    METHOD: GET

**Public Single**

    http://path-to-route-folder/api/c_m_s,_email_marketing/{modulename}/{slug}
    METHOD: GET